package com.ruoyi.web.controller.manager;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.text.CharSequenceUtil;
import com.ruoyi.common.utils.ShiroUtils;
import com.ruoyi.system.domain.tdcase.TdCase;
import com.ruoyi.system.service.tdcase.TdCaseService;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 * packageName com.ruoyi.web.controller.manager
 *
 * @author wangxy
 * @version JDK 8
 * @className TdCaseManager
 * @date 2024/8/13
 * @description 涉密案件管理
 */
@Component
public class TdCaseManager {

    @Resource
    private TdCaseService caseService;

    public List<TdCase> selecttdCaseList(TdCase tdCase) {
        return caseService.selectTdCaseList(tdCase);
    }

    public boolean saveOrUpdate(TdCase tdCase) {
        if (CharSequenceUtil.isNotBlank(tdCase.getId())) {
            tdCase.setUpdateBy(ShiroUtils.getSysUser().getLoginName());
            tdCase.setUpdateTime(new Date());
        } else {
            tdCase.setCreateBy(ShiroUtils.getSysUser().getLoginName());
            tdCase.setCreateTime(new Date());
        }
        return caseService.saveOrUpdate(tdCase);
    }

    public TdCase selecttdCase(String id) {
        return caseService.getById(id);
    }

    public boolean deletedCaseByids(String ids) {
        List<String> list = Arrays.asList(Convert.toStrArray(ids));
        return caseService.removeByIds(list);
    }

    public List<TdCase> selectList() {
        return caseService.lambdaQuery().list();
    }
}
