package com.ruoyi.system.domain.check.dto;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 检查报告结果
 * @author 13560
 * @TableName td_check_report
 */
@Data
public class TdCheckReportDTO implements Serializable {
    /**
     * id
     */
    private String checkId;

    /**
     * 报告人员
     */
    private String adduser;

    /**
     * 报告人单位
     */
    private String depart;

    /**
     * 检查开始时间
     */
    private Date checkStartTime;

    /**
     * 检查结束时间
     */
    private Date checkEndTime;

    /**
     * 检查类型（0.自检 1.保密局检查）
     */
    private String checkType;

    /**
     * 地区
     */
    private String area;

    /**
     * 市州
     */
    private String framework;

    /**
     * 检查状态（0：通过1：未通过2：待检查）
     */
    private String checkState;

    /**
     * 检查人名
     */
    private String checkName;

    /**
     * 创建时间
     */
    private Date createTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    /**
     * 检查类型
     */
    private List<TdCheckTypeDTO> checkTypeDTOS;
}